#  A mud client for
#  Dawn of the Ages  http://dawn.rplay.net
#
#  Copyright (C) 2001,2002 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


import Client
import time;

applets = []
displayers = []

#infograbber_prompt = "<!%h/%Hhp %m/%Mm %v/%Vmv Exits:%e!%Xtnl T:%Y!F:%F!%i!>prompt>"
infograbber_prompt = "<!%h!%H!%m!%M!%v!%V!%e!%x!%X!%Y!%k!%F!%d!%i!%g!%s!%q!%l!%p!%t!%a!%r!%P!%T!%Z!>prompt>"

hp=None
max_hp=10
mana=None
max_mana=10
move=None
max_move=10
exits =""
tnl=1000
tank=None
foe=None
clock=""

#info grabber applet 

class InfoGrabber(Applet):
    def __init__(self):
#        Applet.__init__(self, r"<!([^/]*)/([^h]*)hp ([^/]*)/([^m]*)m ([^/]*)/([^m]*)mv Exits:([^!]*)!([^t]*)tnl T:([^!]*)!F:([^!]*)!([^!]*)!>")
        Applet.__init__(self, r"<!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!([^!]*)!>")
        
        
    def match_fun(self, match, text):
        global hp, max_hp, mana, max_mana, move, max_move, exits, tnl, tank, foe, clock
        #print "match:",match.group(0)
        try:
            hp = int(match.group(1))
        except:
            hp = None
        try:
            max_hp = int(match.group(2))
        except:
            pass

        try:
            mana = int(match.group(3))
        except:
            mana = None

        try:
            max_mana = int(match.group(4))
        except:
            pass

        try:
            move = int(match.group(5))
        except:
            move = None

        try:
            max_move = int(match.group(6))
        except:
            pass
        
        exits = match.group(7)

        try:
            xp = int(match.group(8))
        except:
            xp = None

        try:
            tnl = int(match.group(9))
        except:
            tnl = None
            
        try:
            tank = int(match.group(10))
        except:
            tank = None

        try:
            tank_name = smash_escapes(match.group(11))
        except:
            tank_name = None
            
        try:
            foe = int(match.group(12))
        except:
            foe = None

        try:
            foe_name = smash_escapes(match.group(13))
        except:
            foe_name = None

        clock = match.group(14) 

        try: 
            gold = int(match.group(15))
        except: 
            gold = None
            
        try: 
            silver = int(match.group(16))
        except: 
            silver = None

        try: 
            qp = int(match.group(17))
        except: 
            qp = None

        try: 
            level = int(match.group(18))
        except: 
            level = None

        try: 
            pracs = int(match.group(19))
        except: 
            pracs = None

        try: 
            trains = int(match.group(20))
        except: 
            trains = None

        try: 
            align = match.group(21)
        except: 
            align = None

        try: 
            room_name = smash_escapes(match.group(22))
        except: 
            room_name = None

        try: 
            position = match.group(23)
        except: 
            position = None

        try: 
            sector = match.group(24)
        except: 
            sector = None
            
        try: 
            game_time = match.group(25)
        except: 
            game_time = None

        if client:
            client.set_var("hp",hp)
            client.set_var("max_hp",max_hp)
            client.set_var("mana",mana)
            client.set_var("max_mana",max_mana)
            client.set_var("move",move)
            client.set_var("max_move",max_move)
            client.set_var("exits",exits)
            client.set_var("xp",xp)
            client.set_var("tnl",tnl)
            client.set_var("tank",tank)
            client.set_var("tank_name",tank_name)
            client.set_var("foe",foe)
            client.set_var("foe_name",foe_name)
            client.set_var("clock",clock)
            client.set_var("gold",gold)
            client.set_var("silver",silver)
            client.set_var("qp",qp)
            client.set_var("level",level)
            client.set_var("pracs",pracs)
            client.set_var("trains",trains)
            client.set_var("align",align)
            client.set_var("room_name",room_name)
            client.set_var("position",position)
            client.set_var("sector",sector)
            client.set_var("game_time",game_time)

            if client.clock:
                client.clock.adjust_after(int(game_time.split()[0]))

##            client.hp = hp
##            client.max_hp = max_hp
##            client.mana = mana
##            client.max_mana = max_mana
##            client.move = move
##            client.max_move = max_move
##            client.exits = exits
##            client.xp = xp
##            client.tnl = tnl
##            client.tank = tank
##            client.tank_name = tank_name
##            client.foe = foe
##            client.clock = clock
##            client.gold = gold
##            client.silver = silver
##            client.qp = qp
##            client.level = level
##            client.pracs = pracs
##            client.trains = trains
##            client.align = align
##            client.room_name = room_name
##            client.position = position
##            client.sector = sector
##            client.game_time = game_time
            

            
        return " "

    
applets.append(InfoGrabber())


## clear active affects on reading "You are affected by:" (assuming true affect list follows:)

class AffApplet(Applet):
    def __init__(self):
        Applet.__init__(self, r"^(You are affected by:|\s+Affects:)$")

    def match_fun(self, match, text):
        global actives
        global fadings
        if client.gui:
            client.clear_win("affects")
            client.send_win("affects", "You are affected by:\n")
        else:
            send_fifo(1,CLS)
            send_fifo(1,HOME)
            send_fifo(1,"You are affected by:\n")
        actives = {}
        fadings = {}
        
a = AffApplet()
applets.append(a)


# grab affects command output to fifo 1 
class AffectsApplet(Applet): 
    def __init__(self):
        Applet.__init__(self, r"^\s*(\w+\s?\w+)\s*$|^(.*?)(\s+:\s+)((?:\S+ hours)|(?:permanent))(.*)$")
        #Applet.__init__(self, r"^(.*?)(\s+:\s+)((?:\S+ hours)|(?:permanent))(.*)$")
        

    def match_fun(self, match, text):
        if client.gui:
            client.send_win("affects",match.group(0)+"\n")
        else:
            send_fifo(1,match.group(0)+"\n")
        #output("match:"+match.group(0))
        return None # no gag
        #return "("+string.strip(match.group(1))+")"  #to show gagging
    
applets.append(AffectsApplet())

# grap who to fifo 1
class WhoApplet(Applet):
    def __init__(self):
        Applet.__init__(self, r"^.*?\[\s*(\d+)\s*(.*?)\].*$")
    def match_fun(self, match, text):
        pass
    #send_fifo(1, "Race:"+match.group(2)+" Level:"+match.group(1)+"\n")

applets.append(WhoApplet())


def hmv_disp():
    return reverse()+fg(WHITE)+bg(BLACK)+(("Hps: %s [%d] "+bg(RED)+"Mana:"+bg(BLACK)+" %s Move: %s Exits:%s      \33[0m") %( hp,(int(hp*100/max_hp)), mana, move, exits))+clr()

#displayers.append((10,1,hmv_disp))
              

# grap standard prompt to status bar < unused >
class HMVApplet(Applet):
    def __init__(self):
        Applet.__init__(self, r"<(\d+)hp (\d+)m (\d+)mv Exits:(\w*?)>", 10,1)
    def match_fun(self, match, text):
        self.display=reverse()+fg(WHITE)+bg(BLACK)+("Hp: %s "+bg(RED)+"Mana:"+bg(BLACK)+" %s Move: %s Exits:%s      \33[0m") % (match.group(1),match.group(2),match.group(3),match.group(4))+clr()
        self.draw_exits(match.group(4))
        return " "

# render exit string "NEWSUD" into mini-map

def draw_exits():
    txt = "\33[m"+bold()+reverse()+fg(WHITE)+bg(BLACK)+" "
    if string.find(exits,"N")>=0:
        txt = txt + "|"
    else:
        txt = txt +" "
    if string.find(exits,"U")>=0:
        txt = txt + "/"
    else:
        txt = txt +" "
    txt = txt+"\33[1B\33[3D"
    if string.find(exits,"W")>=0:
        txt = txt + "-"
    else:
        txt = txt +" "
    txt = txt + bg(RED)+"+"+bg(BLACK)
    if string.find(exits,"E")>=0:
        txt = txt + "-"
    else:
        txt = txt +" "
    txt = txt+"\33[1B\33[3D"
    if string.find(exits,"D")>=0:
        txt = txt + "/"
    else:
        txt = txt +" "
    if string.find(exits,"S")>=0:
        txt = txt + "| \33[0m"
    else:
        txt = txt +"  \33[0m"
    return txt



def clock_disp():
    return clock


# return a color in dependance of percent

def color_percent(percent):
    if percent < 25:
        return bold()+fg(RED)
    elif percent < 50:
        return fg(YELLOW)
    elif percent < 75:
        return fg(GREEN)
    else:
        return bold()+fg(GREEN)
    
def print_gauge(value, maxvalue, total_length):
    if value == None:
        return " "*total_length
    if maxvalue > 9999:
        number_length = 5
    elif maxvalue > 999:
        number_length = 4
    else:
        number_length = 4
    bar_length = total_length - number_length
    percent = max(0, int(value*100/maxvalue))
    glen = min(bar_length, max(0, int(value*bar_length/max(1,maxvalue))))
    nr = "%s" % value
    nspace = bar_length+number_length-glen-len(nr)
    return "\33[0m"+color_percent(percent)+("="*glen)+(" "*nspace)+nr+"\33[0m"

hp_gauge_width = 20
mana_gauge_width = 20
move_gauge_width = 20
tank_gauge_width = 35
foe_gauge_width = 35


def hp_gauge():
    return print_gauge(hp, max_hp, hp_gauge_width)
def mana_gauge():
    return print_gauge(mana, max_mana, mana_gauge_width)
def move_gauge():
    return print_gauge(move, max_move, move_gauge_width)
def tank_gauge():
    return print_gauge(tank, 100, tank_gauge_width)
def foe_gauge():
    return print_gauge(foe, 100, foe_gauge_width)

    
def draw_spells():
    vals = actives.values()
    vals.sort()
    erg = ""
    #erg = erg + "     "*9 +"\33[1B\33[50D" + "     "*9
    i=0
    for v in vals:
        erg = erg + v
        i = i+1
        if i  == (10-1):		     # 9 affects in the first line
   	    erg = erg + "\33[1B\33[50D"	     # 1 line down and 50 (10*5) characters left
	else:
            if (i-(10-1))%10 == 0: 	     # 10 affects in any successive line
                erg = erg + "\33[1B\33[50D"  # 1 line down and 50 (10*5) characters left
    return "Aff: "+erg+"         "
 

def expression(var):
    return  "%s" % eval(var)

 
#affects = []
	
